<?php
/***************************************************************************
 *                              onlinenews.php
 *                           -------------------
 *   Begin                : Monday, March 24, 2006
 *   Copyright            : (C) 2006 kambodianboi
 *   Email                : kambodianboi@yahoo.com
 *   Website              : www.phpdragon.com - Testing only
 ***************************************************************************/


define('IN_PHPBB', true);

// Admin Panel
if( !empty($setmodules) )
{
        $filename = basename(__FILE__);
        $module['RSS Feed']['Manage'] = $filename . '?mode=view';
        $module['RSS Feed']['Categories'] = $filename . '?mode=cats';
        return;
}

// Load default header
$phpbb_root_path = "../";
require($phpbb_root_path . 'extension.inc');
require('pagestart.' . $phpEx);


if( isset($HTTP_POST_VARS['mode']) )
{
        $mode = $HTTP_POST_VARS['mode'];
}
else if( isset($HTTP_GET_VARS['mode']) )
{
        $mode = $HTTP_GET_VARS['mode'];
}

if($mode == "view")
{
        $template->set_filenames(array(
                'body' => 'admin/admin_rss_body.tpl')
        );

        $sql = "SELECT *
               FROM ". RSS_TABLE;

        if(!$result = $db->sql_query($sql))
        {
                message_die(GENERAL_ERROR, "No puede preguntar la informacin de las noticias de RSS", "", __LINE__, __FILE__, $sql);
        }

        $i = 0;
        while( $row = $db->sql_fetchrow($result) )
        {
                $i++;

                // Header 0, Footer 1, News 2, Portal 3, Portal #2 4
                $page_rows = array('Header', 'Footer', 'News Page', 'Portal', 'Portal #2');

                for($j = 0; $j < count($page_rows); $j++)
                {
                        if($row['rss_location'] == $j)
                        {
                                $page_select = $page_rows[$j];
                        }
                }

                // rss_id, rss_url, rss_enable, rss_limit, rss_location
                $template->assign_block_vars("rss_row", array(
                           'RSS_EDIT' => append_sid("admin_rss_news.$phpEx?mode=edit&amp;rss_id=" . $row['rss_id']),
                           'RSS_DELETE' => append_sid("admin_rss_news.$phpEx?mode=delete&amp;rss_id=" . $row['rss_id']),
                           'RSS_NUM' => $i,
                           'RSS_ENABLED' => $row['rss_enable'] ? 'Si' : 'No',
                           'RSS_PAGE' => $page_select,
                           'RSS_COMMENT' => $row['rss_name'],
                           'RSS_LIMIT' => $row['rss_limit']
                           )
                );
        }

        $template->assign_vars(array(
                'S_RSS_ACTION' => append_sid("admin_rss_news.".$phpEx),
                'L_RSS_NUM' => '#',
                'L_RSS_COMMENT' => 'Nombre',
                'L_RSS_ENABLED' => 'Permitir',
                'L_RSS_LIMIT' => 'Lmite',
                'L_RSS_LOCATION' => 'Pgina',
                'L_RSS_EDIT' => 'Editar',
                'L_RSS_DELETE' => 'Eliminar',
                'L_ADD_RSS' => 'Agregar Nuevo'
                )
        );
}
elseif($mode == "delete")
{
        if( isset($HTTP_POST_VARS['rss_id']) || isset($HTTP_GET_VARS['rss_id']) )
        {
                $rss_id = ( isset($HTTP_POST_VARS['rss_id']) ) ? intval($HTTP_POST_VARS['rss_id']) : intval($HTTP_GET_VARS['rss_id']);
        }
        else
        {
                $rss_id = '';
        }

        if( !empty($rss_id ))
        {
                $sql = "DELETE FROM " . RSS_TABLE . "
                        WHERE rss_id = '$rss_id'";

                if( !$result = $db->sql_query($sql) )
                {
                        message_die(GENERAL_ERROR, "No se puede eliminar datos de RSS", "", __LINE__, __FILE__, $sql);
                }

                $message = "El RSS a sido eliminado.<br /><br />Click <a href=\"" . append_sid("admin_rss_news.$phpEx?mode=view") . "\">Aqui</a> para volver a la RSS Administracin<br /><br />Click <a href=\"" . append_sid("index.$phpEx?pane=right") . "\">Aqui</a> para volver al indice del Administrador";
                message_die(GENERAL_MESSAGE, $message);
        }
        else
        {
                message_die(GENERAL_MESSAGE, 'Falta identificar RSS.');
        }
}
elseif($mode == "edit" || $mode == "add")
{
        $template->set_filenames(array(
                'body' => 'admin/admin_rss_add_body.tpl')
        );

        $sql = "SELECT * FROM phpbb_rss_cat";

        if(!$result = $db->sql_query($sql))
        {

        }

        while($row = $db->sql_fetchrow($result))
        {
                $rss_cat[] = $row;
        }

        if($mode == "edit")
        {
                if( isset($HTTP_POST_VARS['rss_id']) || isset($HTTP_GET_VARS['rss_id']) )
                {
                        $rss_id = ( isset($HTTP_POST_VARS['rss_id']) ) ? intval($HTTP_POST_VARS['rss_id']) : intval($HTTP_GET_VARS['rss_id']);
                }
                else
                {
                        $rss_id = '';
                }

                $sql = "SELECT * FROM " . RSS_TABLE . "
                        WHERE rss_id = '$rss_id'";

                if( !$result = $db->sql_query($sql) )
                {
                        message_die(GENERAL_ERROR, "No se puede eliminar datos de RSS", "", __LINE__, __FILE__, $sql);
                }

                $row = $db->sql_fetchrow($result);

                // rss_id, rss_url, rss_enable, rss_limit, rss_location, rss_comment
                $rss_url = $row['rss_url'];
                $rss_enable = $row['rss_enable'];
                $rss_limit = $row['rss_limit'];
                $rss_page = $row['rss_location'];
                $rss_comment = $row['rss_name'];
                $rss_id = $row['rss_id'];

                if($rss_enable == 1)
                {
                        $template->assign_vars(array(
                           'RSS_ACTIVE' => 'checked="checked"'
                           )
                        );
                }
                else
                {
                        $template->assign_vars(array(
                           'RSS_NOT_ACTIVE' => 'checked="checked"'
                           )
                        );
                }
        }
        else
        {
                $template->assign_vars(array(
                           'RSS_ACTIVE' => 'checked="checked"'
                           )
                        );
        }

        $options = "<select name=\"rss_cat\">";
        for($i=0;$i<count($rss_cat);$i++)
        {
                if($row['rss_cat'] == $rss_cat[$i]['rss_cat_id'])
                {
                        $options .= "<option value=\"".$rss_cat[$i]['rss_cat_id']."\" selected>".$rss_cat[$i]['rss_cat_name']."</option>";
                }
                else
                {
                        $options .= "<option value=\"".$rss_cat[$i]['rss_cat_id']."\">".$rss_cat[$i]['rss_cat_name']."</option>";
                }
        }
        $options .= "</select>";

        // Header 0, Footer 1, News 2, Portal 3, Portal #2 4
        $page_rows = array('Header', 'Footer', 'News Page', 'Portal', 'Portal #2');

        $page_select_list = '<select name="rss_page">';
        for($i = 0; $i < count($page_rows); $i++)
        {
                if($mode == "edit" && $rss_page == $i)
                {
                        $page_select_list .= '<option value="' . $i . '" selected>' . $page_rows[$i] . '</option>';
                }
                else
                {
                        $page_select_list .= '<option value="' . $i . '">' . $page_rows[$i] . '</option>';
                }
        }

        $page_select_list .= '</select>';

        $template->assign_vars(array(
                'S_RSS_ACTION' => append_sid("admin_rss_news.".$phpEx),
                'L_RSS_URL' => 'RSS URL',
                'L_RSS_COMMENT' => 'Nombre',
                'L_RSS_ENABLED' => 'Permitir',
                'L_RSS_LIMIT' => 'Lmite',
                'L_RSS_LOCATION' => 'Pgina',
                'L_YES' => "Si",
                'L_NO' => "No",
                'L_SUBMIT' => "Enviar",
                'L_RESET' => "Reset",
                'CAT_OPTION' => $options,
                'L_RSS_CAT' => "RSS Categoria",
                'RSS_URL' => $rss_url,
                'RSS_COMMENT' => $rss_comment,
                'RSS_ENABLED' => $rss_enable,
                'RSS_LIMIT' => $rss_limit,
                'RSS_LOCATION' => $page_select_list,

                'S_HIDDEN_FIELDS' => '<input type="hidden" name="rss_id" value="'.$rss_id.'"><input type="hidden" name="mode" value="save">'
                )
        );
}
elseif($mode == "save")
{
        if( isset($HTTP_POST_VARS['rss_id']) || isset($HTTP_GET_VARS['rss_id']) )
        {
                $rss_id = ( isset($HTTP_POST_VARS['rss_id']) ) ? intval($HTTP_POST_VARS['rss_id']) : intval($HTTP_GET_VARS['rss_id']);
        }
        else
        {
                $rss_id = '';
        }

        //Clean all HTTP info
        $rss_url = ( isset($HTTP_POST_VARS['rss_url']) ) ? trim($HTTP_POST_VARS['rss_url']) : "";
        $rss_enable = ( isset($HTTP_POST_VARS['rss_enable']) ) ? trim($HTTP_POST_VARS['rss_enable']) : "";
        $rss_limit = ( isset($HTTP_POST_VARS['rss_limit']) ) ? trim($HTTP_POST_VARS['rss_limit']) : "";
        $rss_page = ( isset($HTTP_POST_VARS['rss_page']) ) ? trim($HTTP_POST_VARS['rss_page']) : "";
        $rss_comment = ( isset($HTTP_POST_VARS['rss_comment']) ) ? trim($HTTP_POST_VARS['rss_comment']) : "";
        $rss_cat = ( isset($HTTP_POST_VARS['rss_cat']) ) ? trim($HTTP_POST_VARS['rss_cat']) : "3";

        if(empty($rss_url) || empty($rss_comment))
        {
                message_die(GENERAL_ERROR, "Tienes que incorporar un URL y/o un comentario para guardar tu fuente de la alimentacin de RSS.");
        }

        if( !empty($rss_id) )
        {
                $sql = "UPDATE " . RSS_TABLE . "
                        SET rss_url = '".str_replace("\'", "''", $rss_url)."',
                        rss_enable = '".str_replace("\'", "''", $rss_enable)."',
                        rss_limit = '".str_replace("\'", "''", $rss_limit)."',
                        rss_name = '".str_replace("\'", "''", $rss_comment)."',
                        rss_location = '".str_replace("\'", "''", $rss_page)."',
                        rss_cat = '".str_replace("\'", "''", $rss_cat)."'
                        WHERE rss_id = '$rss_id'";

                $action = 'Actualizado';
        }
        else
        {
                $sql = "SELECT MAX(rss_id) as rss_id FROM " . RSS_TABLE;
                if(!$result = $db->sql_query($sql))
                {
                        message_die(GENERAL_ERROR, "No se puede obtener datos de identificacin del banner", "", __LINE__, __FILE__, $sql);
                }
                $rss_nr = $db->sql_fetchrow($result);
                $rss_id = $rss_nr['rss_id']+1;
                $sql = "INSERT INTO " . RSS_TABLE . " (rss_id, rss_name, rss_enable, rss_limit, rss_location, rss_url, rss_cat)
                        VALUES ('$rss_id','" . str_replace("\'", "''", $rss_comment) . "', '$rss_enable', '$rss_limit', '$rss_page', '" . str_replace("\'", "''", $rss_url) . "', $rss_cat)";
                $action = 'aadido';
        }
        if( !$result = $db->sql_query($sql) )
        {
                message_die(GENERAL_ERROR, "No se puede actualizar/rellene la tabla de los RSS.", "", __LINE__, __FILE__, $sql);
        }

        $message = "El RSS ha sido ".$action." satisfactoriamente.<br /><br />Click <a href=\"" . append_sid("admin_rss_news.$phpEx?mode=view") . "\">Aqui</a> para volver a la RSS Administracin<br /><br />Click <a href=\"" . append_sid("index.$phpEx?pane=right") . "\">Aqui</a> para volver al indice del Administrador";
        message_die(GENERAL_MESSAGE, $message);
}
elseif($mode == "cats")
{
        if( isset($HTTP_POST_VARS['action']) )
        {
                $action = $HTTP_POST_VARS['action'];
        }
        else if( isset($HTTP_GET_VARS['action']) )
        {
                $action = $HTTP_GET_VARS['action'];
        }

        $template->set_filenames(array(
                'body' => 'admin/admin_rss_cat.tpl')
        );

        if($action == "save")
        {
                $rss_cat_name = ( isset($HTTP_POST_VARS['rss_cat_name']) ) ? trim($HTTP_POST_VARS['rss_cat_name']) : "";

                $sql = "SELECT MAX(rss_cat_id) as rss_cat_count FROM " . RSS_CAT_TABLE;

                if(!$result = $db->sql_query($sql))
                {
                        message_die(GENERAL_ERROR, "No se puede obtener datos RSS categoria", "", __LINE__, __FILE__, $sql);
                }

                $rss_nr = $db->sql_fetchrow($result);

                $rss_id = $rss_nr['rss_cat_count']+1;

                $sql = "INSERT INTO " . RSS_CAT_TABLE . " (rss_cat_name)
                        VALUES ('" . str_replace("\'", "''", $rss_cat_name) . "')";

                if( !$result = $db->sql_query($sql) )
                {
                        message_die(GENERAL_ERROR, "No se puede actualizar/rellene la tabla de los RSS.", "", __LINE__, __FILE__, $sql);
                }
        }
        elseif($action == "delete")
        {
                if( isset($HTTP_POST_VARS['rss_cat_id']) || isset($HTTP_GET_VARS['rss_cat_id']) )
                {
                        $rss_cat_id = ( isset($HTTP_POST_VARS['rss_cat_id']) ) ? intval($HTTP_POST_VARS['rss_cat_id']) : intval($HTTP_GET_VARS['rss_cat_id']);
                }
                else
                {
                        $rss_cat_id = '';
                }

                if( !empty($rss_cat_id ))
                {
                        $sql = "DELETE FROM " . RSS_CAT_TABLE . "
                                WHERE rss_cat_id = '$rss_cat_id'";

                        if( !$result = $db->sql_query($sql) )
                        {
                                message_die(GENERAL_ERROR, "No se puede eliminar datos de RSS", "", __LINE__, __FILE__, $sql);
                        }
                }
                else
                {
                        message_die(GENERAL_MESSAGE, 'Falta identificar RSS categoria.');
                }
        }

        $sql = "SELECT * FROM ".RSS_CAT_TABLE."";

        if( !$result = $db->sql_query($sql) )
        {
                message_die(GENERAL_ERROR, "No se puede eliminar datos de RSS", "", __LINE__, __FILE__, $sql);
        }

        while($row = $db->sql_fetchrow($result))
        {
                $template->assign_block_vars("rss_cat_row", array(
                           'RSS_CAT_NAME' => $row['rss_cat_name'],
                           'RSS_CAT_DELETE' => append_sid("admin_rss_news.$phpEx?mode=cats&amp;action=delete&amp;rss_cat_id=" . $row['rss_cat_id']),
                           )
                );
        }

        $template->assign_vars(array(
                'S_RSS_ACTION' => append_sid("admin_rss_news.".$phpEx),
                'L_RSS_URL' => 'RSS URL',
                'L_RSS_CAT_NUM' => '#',
                'L_RSS_CAT_NAME' => 'Nombre de Categoria',
                'L_RSS_CAT_DELETE' => 'Eliminar',
                'L_ADD_RSS' => 'Agregar Categoria'
                )
        );
}

$template->pparse("body");

// Page Footer
include("page_footer_admin.$phpEx");
?>