<?php
/***************************************************************************
 *                              onlinenews.php
 *                           -------------------
 *   Begin                : Monday, March 24, 2006
 *   Copyright            : (C) 2006 kambodianboi
 *   Email                : kambodianboi@yahoo.com
 *   Website              : www.phpdragon.com - Testing only
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_RSS);
init_userprefs($userdata);
//
// End session management
//

$cat_id = $HTTP_GET_VARS['cat_id'];
$rss_id = $HTTP_GET_VARS['rss_id'];

if(!isset($HTTP_GET_VARS['mode']))
{
        $page_title = 'NewsFeed';
        include($phpbb_root_path . 'includes/page_header.'.$phpEx);
}
else
{
        include('includes/functions_rss.'.$phpEx);
}

$sql = "SELECT * FROM ". RSS_CAT_TABLE ."
        ORDER BY rss_cat_name ASC";

if(!$result = $db->sql_query($sql))
{
        message_die(GENERAL_ERROR, "Could not query RSS news information", "", __LINE__, __FILE__, $sql);
}

$rss_rows = array();
while( $row = $db->sql_fetchrow($result) )
{
        $rss_rows[] = $row;
}


for($i=0;$i<count($rss_rows);$i++)
{
        $sql = "SELECT COUNT(rss_id) as count FROM ".RSS_TABLE."
                WHERE rss_cat = ".$rss_rows[$i]['rss_cat_id']."
                AND rss_location = 2";

        if(!$result = $db->sql_query($sql))
        {
                message_die(GENERAL_ERROR, "Could not query RSS news information", "", __LINE__, __FILE__, $sql);
        }

        $row[$i] = $db->sql_fetchrow($result);

        $template->assign_block_vars("rss_cats", array(
                                      'U_RSS_CAT' =>  "<div class=\"gensmall\" style=\"cursor:pointer\" onclick=\"SwitchMenu('sub".$rss_rows[$i]['rss_cat_id']."')\">".$rss_rows[$i]['rss_cat_name']." (".$row[$i]['count']." Sources)</div>",
                                      'CAT_ID' => $rss_rows[$i]['rss_cat_id']
                                      )
        );

        // Header 0, Footer 1, News 2, Portal 3
        $sql = "SELECT * FROM ".RSS_TABLE."
                WHERE rss_cat = ".$rss_rows[$i]['rss_cat_id']."
                AND rss_location = 2
                AND rss_enable = 1";

        if(!$result = $db->sql_query($sql))
        {
                message_die(GENERAL_ERROR, "Could not query RSS news information", "", __LINE__, __FILE__, $sql);
        }

        while( $row1[$i] = $db->sql_fetchrow($result) )
        {
                $rss_rows1[$i][] = $row1[$i];
        }

        for($j=0;$j<count($rss_rows1[$i]);$j++)
        {
                $template->assign_block_vars("rss_cats.rss_list", array(
                                              'U_RSS' => "<a href=\"".append_sid('onlinenews.'.$phpEx."?rss_id=".$rss_rows1[$i][$j]['rss_id'])."\">".$rss_rows1[$i][$j]['rss_name']."</a>",
                                              'C_RSS' => $rss_rows1[$i][$j]['rss_limit']
                                              )
                );
        }
}

if(isset($rss_id))
{
        $template->set_filenames(array(
                   'body' => 'rss_cat_body.tpl')
        );

        $sql = "SELECT * FROM ".RSS_TABLE."
                WHERE rss_id = ".$rss_id."";

        if(!$result = $db->sql_query($sql))
        {
                message_die(GENERAL_ERROR, "Could not query RSS news information", "", __LINE__, __FILE__, $sql);
        }

        $rss_rows = array();
        $row = $db->sql_fetchrow($result);

        $rss = new rss();
        $rss->$items_limit = $row['rss_limit'];
        $rss_items = $rss->Get($row['rss_url']);
        $max_rss = ($rss_items['items_count'] < $row['rss_limit']) ? $rss_items['items_count'] : $row['rss_limit'];

        $template->assign_block_vars("rss_cat_off", array(
                                             'RSS_SOURCE' => $rss_items['title']
                                             )
                                    );

        for($i=0;$i<$max_rss;$i++)
        {
                $template->assign_block_vars("rss_cat_off.rss_list", array(
                                              'RSS_ARTC_BODY' => !empty($rss_items['items'][$i]['body']) ? $rss_items['items'][$i]['body'] : $rss_items['items'][$i]['description'],
                                              'RSS_ARTC_TITLE' => "<a href=\"".$rss_items['items'][$i]['link']."\" target=\"_child\">".$rss_items['items'][$i]['title']."</a>",
                                              'RSS_ARTC_TIME' => $rss_items['items'][$i]['date'],
                                              )
                );
        }
}
elseif(isset($cat_id))
{
        $template->set_filenames(array(
                   'body' => 'rss_cat_body.tpl')
        );

        // Header 0, Footer 1, News 2, Portal 3
        $sql = "SELECT * FROM ".RSS_TABLE."
                WHERE rss_cat = ".$cat_id."
                AND rss_location = 2
                AND rss_enable = 1";

        if(!$result = $db->sql_query($sql))
        {
                message_die(GENERAL_ERROR, "Could not query RSS news information", "", __LINE__, __FILE__, $sql);
        }

        $rss_rows = array();
        while( $row = $db->sql_fetchrow($result) )
        {
                $rss_rows[] = $row;
        }

        $template->assign_block_vars("rss_cat_on", array());

        for($i=0;$i<count($rss_rows);$i++)
        {
                $template->assign_block_vars("rss_cat_on.rss_list", array(
                                              'U_RSS' => "<a href=\"".append_sid('onlinenews.'.$phpEx."?rss_id=".$rss_rows[$i]['rss_id'])."\">".$rss_rows[$i]['rss_name']."</a>",
                                              'C_RSS' => $rss_rows[$i]['rss_limit']
                                              )
                );
        }
}
else
{
        $template->set_filenames(array(
                   'body' => 'rss_cat_body.tpl')
        );

        $sql = "SELECT * FROM ".RSS_TABLE."
                WHERE rss_id = ".rand(1,count($rss_rows));

        if(!$result = $db->sql_query($sql))
        {
                message_die(GENERAL_ERROR, "Could not query RSS news information", "", __LINE__, __FILE__, $sql);
        }

        $rss_rows = array();
        $row = $db->sql_fetchrow($result);

        $rss = new rss();
        $rss->$items_limit = $row['rss_limit'];
        $rss_items = $rss->Get($row['rss_url']);
        $max_rss = ($rss_items['items_count'] < $row['rss_limit']) ? $rss_items['items_count'] : $row['rss_limit'];

        $template->assign_block_vars("rss_cat_off", array(
                                             'RSS_SOURCE' => $rss_items['title']
                                             )
                                    );

        for($i=0;$i<$max_rss;$i++)
        {
                $template->assign_block_vars("rss_cat_off.rss_list", array(
                                              'RSS_ARTC_BODY' => !empty($rss_items['items'][$i]['body']) ? $rss_items['items'][$i]['body'] : $rss_items['items'][$i]['description'],
                                              'RSS_ARTC_TITLE' => "<a href=\"".$rss_items['items'][$i]['link']."\" target=\"_child\">".$rss_items['items'][$i]['title']."</a>",
                                              'RSS_ARTC_TIME' => $rss_items['items'][$i]['date'],
                                              )
                );
        }
}
//
// Generate the page
//
$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
?>